#[doc = "Register `CTL3` reader"]
pub struct R(crate::R<CTL3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CTL3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CTL3_SPEC>> for R {
    fn from(reader: crate::R<CTL3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CTL3` writer"]
pub struct W(crate::W<CTL3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CTL3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CTL3_SPEC>> for W {
    fn from(writer: crate::W<CTL3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CTL_LS` reader - Control register for UDB\\[n\\]"]
pub struct CTL_LS_R(crate::FieldReader<u8, u8>);
impl CTL_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        CTL_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CTL_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CTL_LS` writer - Control register for UDB\\[n\\]"]
pub struct CTL_LS_W<'a> {
    w: &'a mut W,
}
impl<'a> CTL_LS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u16 & 0xff);
        self.w
    }
}
#[doc = "Field `CTL_MS` reader - Control register for UDB\\[n+1\\]"]
pub struct CTL_MS_R(crate::FieldReader<u8, u8>);
impl CTL_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        CTL_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CTL_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CTL_MS` writer - Control register for UDB\\[n+1\\]"]
pub struct CTL_MS_W<'a> {
    w: &'a mut W,
}
impl<'a> CTL_MS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u16 & 0xff) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Control register for UDB\\[n\\]"]
    #[inline(always)]
    pub fn ctl_ls(&self) -> CTL_LS_R {
        CTL_LS_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Control register for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn ctl_ms(&self) -> CTL_MS_R {
        CTL_MS_R::new(((self.bits >> 8) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Control register for UDB\\[n\\]"]
    #[inline(always)]
    pub fn ctl_ls(&mut self) -> CTL_LS_W {
        CTL_LS_W { w: self }
    }
    #[doc = "Bits 8:15 - Control register for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn ctl_ms(&mut self) -> CTL_MS_W {
        CTL_MS_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctl3](index.html) module"]
pub struct CTL3_SPEC;
impl crate::RegisterSpec for CTL3_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [ctl3::R](R) reader structure"]
impl crate::Readable for CTL3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [ctl3::W](W) writer structure"]
impl crate::Writable for CTL3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CTL3 to value 0"]
impl crate::Resettable for CTL3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
